var action = "shutdown";
var H = 1;
var M = 0;
var S = 0;

function editHoursOnChange(Sender)
{
 editHours.Text = editHours.Text.replace(/^\s+|\s+$/g, '');
 editHours.Text = editHours.Text == "" ? "0" : editHours.Text; 
  if(parseInt(editHours.Text) > 23){
    editHours.Text = "23";
  }
  H = parseInt(editHours.Text);
}

function editMinutesOnChange(Sender)
{
editMinutes.Text = editMinutes.Text.replace(/^\s+|\s+$/g, '');
 editMinutes.Text = editMinutes.Text == "" ? "0" : editMinutes.Text;
  if(parseInt(editMinutes.Text) > 59){
    editMinutes.Text = "59";
  }
  M = parseInt(editMinutes.Text);
}

function editSecondsOnChange(Sender)
{
  editSeconds.Text = editSeconds.Text.replace(/^\s+|\s+$/g, '');
 editSeconds.Text = editSeconds.Text == "" ? "0" : editSeconds.Text;
  if(parseInt(editSeconds.Text) > 59){
    editSeconds.Text = "59";
  }
  S = parseInt(editSeconds.Text);
}

function checkSpegniOnChange(Sender)
{
  if(checkSpegni.Checked){
    checkRiavvia.Checked = false;
    checkSospendi.Checked = false;
    checkDisconnetti.Checked = false;
    action = "shutdown";
  } else {
    if (checkSpegni.Checked == false && checkRiavvia.Checked == false && checkSospendi.Checked == false && checkDisconnetti.Checked == false){
      checkSpegni.Checked = true;
    }
  }
}

function checkRiavviaOnChange(Sender)
{
  if(checkRiavvia.Checked){
    checkSpegni.Checked = false;
    checkSospendi.Checked = false;
    checkDisconnetti.Checked = false; 
    action = "restart";
  } else {
    if (checkSpegni.Checked == false && checkRiavvia.Checked == false && checkSospendi.Checked == false && checkDisconnetti.Checked == false){
      checkRiavvia.Checked = true;
    }
  }
}

function checkSospendiOnChange(Sender)
{
  if(checkSospendi.Checked){
    checkSpegni.Checked = false;
    checkRiavvia.Checked = false;
    checkDisconnetti.Checked = false;
    action = "sleep";
  } else {
    if (checkSpegni.Checked == false && checkRiavvia.Checked == false && checkSospendi.Checked == false && checkDisconnetti.Checked == false){
      checkSospendi.Checked = true;
    }
  } 
}

function checkDisconnettiOnChange(Sender)
{
  if(checkDisconnetti.Checked){
    checkSpegni.Checked = false;
    checkRiavvia.Checked = false;
    checkSospendi.Checked = false;
    action = "logout";
  } else {
    if (checkSpegni.Checked == false && checkRiavvia.Checked == false && checkSospendi.Checked == false && checkDisconnetti.Checked == false){
      checkDisconnetti.Checked = true;
    }
  }
}

function layerBackgroundOnDblClick(Sender)
{
  timercore.Enabled = false;
  widget.flip();
}

function layerBackgroundBackOnDblClick(Sender)
{
  if(timercore.Enabled == false){
    txtTimer.Text = "00.00.00";
    txtMessage.Text = "Shutdown Timer";
  }
  widget.flip();
}

function timercoreOnUpdate(Sender)
{
  if (S > 0){
    S = S - 1;
  } else if (M > 0) {
    M = M -1;
    S = 59;
  } else if (H > 0){
    H = H - 1;
    M = 59;
    S = 59;
  } else {
    timercore.Enabled = false;
    txtMessage.Text = "Shutdown Timer";
    doAction();
  }
  updateFront();
}

function doAction(){
  switch(action){
    case "shutdown":
      run("shutdown.exe -s -t 00");
    break;
    case "restart":
      run("shutdown.exe -r -t 00");
    break;
    case "sleep":
      run("rundll32.exe powrprof.dll,SetSuspendState");
    break;
    case "logout":
      run("shutdown.exe -L");
    break;
  }
}

function f(s){
  if (s < 10){
    return "0" + s;
  } else {
    return s;
  }
}

function updateFront(){
  txtTimer.Text = f(H) + "." + f(M) + "." + f(S);
}


function imgStartOnClick(Sender)
{
H = parseInt(editHours.Text);
    M = parseInt(editMinutes.Text);
    S = parseInt(editSeconds.Text);
  if(H + M + S > 0){
    
    switch(action){
    case "shutdown":
      txtMessage.Text = "Shutdown in";
    break;
    case "restart":
      txtMessage.Text = "Restart in";
    break;
    case "sleep":
      txtMessage.Text = "Suspend in";
    break;
    case "logout":
      txtMessage.Text = "Logout in";
    break;
   }
    
    timercore.Enabled = true;
    widget.flip();
  }else{
    alert("Set timer value!");
  }
}
